<?= $element->renderSubmenu('/9-lekce-funkce'); ?>

<h1 class="mainTitle"><?= $template->title; ?></h1>

<p>Už jsme se o nich několkrát bavili. Už jsme je dokonce použili. A teď si je vysvětlíme podrobněji.</p>

<p>
	Funkci použijeme ve chvíli, kdy chceme stejný kus kódu používat na více místech v programu. Např. početní úkony, odeslání e-mailu, načítání souboru, generování stránky.
	Místo toho, abychom stejný kus kódu (třeba 50 řádků) psali na 5 místech, vytvoříme si funkci. Do funkce napíšeme oněch 50 řádků a pak na těch 5 místech voláme naši funkci.
	Stačí si vzpomenout na všechny <a href="https://www.php.net/manual/en/indexes.functions.php" target="_blank">systémové funkce</a>, které jste již použili.
</p>

<p class="font-bold">A takto funkce vypadá</p>
<pre class="php">
&lt;?php
    <span class="php__syntax">function</span> <span class="php__fun">nazevFunkce</span>(<span class="php__var">$argumentFunkce1</span>, ...) {
        .
        .
        <span class="php__syntax">return</span> <span class="php__var">$promenna</span>;
    }
    .
    .
    .
    <span class="php__fun">nazevFunkce</span>(<span class="php__var">$promenna</span>); <span class="php__comment">// Takto poté funkci voláte.</span>
?&gt;
</pre>

<p>
	Nejprve napíšeme klíčové slovíčko <b class="text-pink-dark">function</b>. Poté následuje název funkce.
	Pro její název platí stejná pravidla jako pro proměnné. Následuje závorka. Uvnitř závorky poté můžeme říci, že funkce vyžaduje argumenty/parametry (hodnoty, se kterými bude funkce pracovat).
	Počet argumentů je neomezený. Funkce poté může vracet i nějakou hodnotu.<br>
	PS: Ty tečky značí nějakou část kódu, kterou jsme napsali mezi naší funkcí a jejím volání.
</p>

<h2 class="text-xl">Příklady</h2>

<p>Funkce bez argumentů, která vrací vygenerované číslo.</p>
<pre class="php">
&lt;?php
    <span class="php__syntax">function</span> <span class="php__fun">vygenerujCislo</span>() {
        <span class="php__syntax">return</span> <span class="php__fun">rand</span>();
    }
    .
    .
    .
    <span class="php__var">$vygenerovaneCislo</span> = <span class="php__fun">vygenerujCislo</span>(); <span class="php__comment">// Zavolám funkci a její vrácenou hodnotu přiřadím do proměnné.</span>
?&gt;
</pre>

<p>Funkce bez argumentů, která pouze smaže session a nic nevrací.</p>
<pre class="php">
&lt;?php
    <span class="php__syntax">function</span> <span class="php__fun">smazSession</span>() {
        <span class="php__syntax">unset</span>(<span class="php__var">$_SESSION</span>);
    }
    .
    .
    .
    <span class="php__fun">smazSession</span>(); <span class="php__comment">// Pouze zavolám funkci.</span>
?&gt;
</pre>

<p>Funkce vypočte cenu s DPH.</p>
<pre class="php">
&lt;?php
    <span class="php__syntax">function</span> <span class="php__fun">spocitejCenuSDph</span>(<span class="php__var">$cenaBezDph</span>, <span class="php__var">$dph</span> = <span class="php__num">21</span>) {
        <span class="php__var">$cenaSDph</span> = <span class="php__var">$cenaBezDph</span> * (<span class="php__num">1</span> + <span class="php__var">$dph</span> / <span class="php__num">100</span>);
        <span class="php__syntax">return</span> <span class="php__var">$cenaSDph</span>;
    }
    .
    .
    .
    <span class="php__var">$cenaSDph1</span> = <span class="php__fun">spocitejCenuSDph</span>(<span class="php__num">125</span>, <span class="php__num">15</span>); <span class="php__comment">// Zavolám funkci, předám argumenty a její vrácenou hodnotu přiřadím do proměnné.</span>
    <span class="php__comment">// Zde bude DPH 15%.</span>
    .
    .
    <span class="php__var">$dphProCenu</span> = <span class="php__num">10</span>;
    <span class="php__var">$cenaSDph2</span> = <span class="php__fun">spocitejCenuSDph</span>(<span class="php__num">456</span>, <span class="php__var">$dphProCenu</span>); <span class="php__comment">// Někde dále funkci zavolám znovu.</span>
    <span class="php__comment">// Zde bude DPH 10%.</span>
    .
    .
    <span class="php__var">$cenaSDph3</span> = <span class="php__fun">spocitejCenuSDph</span>(<span class="php__num">789</span>); <span class="php__comment">// A ještě dále ji opět zavolám.</span>
    <span class="php__comment">// Zde bude DPH 21%.</span>
?&gt;
</pre>

<p>
	U příkladu výše si můžete všimnout, že argument (ve funkci už se z něj stává proměnná, která platí pouze ve funkci) <b>$dph</b> má přiřazenou defaultní hodnotu. Pak mu říkáme nepovinný argument.
	To znamená, že i když má funkce 2 argumenty, tak když ji voláme, tak jej můžeme vynechat. Když jej vynecháme, ve funkci v proměnné <b>$dph</b> poté bude tato defaultní hodnota.</p>